package Client::ProcMgr;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>


use Util;
use AutoForm;
use strict;
use Tasks;
use Cache;
use Html::List;
use System;
use Scheduler;
use Client;
use Process;

#
# LIST ALL CURRENT PROCESSES 
#
sub list {
  my($q) = @_;
  my($renv, $devs, $hosts,$notifs, $command, $opts, $sel,$local );
  my($out, $tag);
  $q->{prefix}  = "StorTools" if (!$q->{prefix});
  my $prefix = uc(substr($q->{prefix},0,2)) || "ST";
  print Client->http_OK();

  my $PLIST = $q->{PLIST}; # process _list

  my $MODE = $q->{MODE};

  my $cnt = 0;
  my $running;
  my(@DATA);
  my $D1 = System->get_home() . "/DATA/Proc";
  opendir(O, $D1);
  my @hd = readdir(O); closedir(O);
  print "<PROCESSES>\n";

  foreach my $hostname (@hd) {
     next if (!-d "$D1/$hostname");
     my $list = Scheduler->processList($prefix,$hostname, 
                             {status => $MODE, plist => $PLIST} );

     foreach my $l (@$list) {
        my $sh   = Util->shortHostname($l->{host});
        my $host = $l->{host};
        my $pid  = $l->{pid};
        my $pid0  = sprintf("%6.6d", $l->{pid});
        my $status = &_status($l);
        my $start = $l->{start_date};
        my $end   = $l->{end_date};

        $end = substr($end,11) if (substr($start,0,10) eq substr($start,0,10));
        print <<EOF;
   <PROCESS>
     <ID>$pid</ID>
     <TYPE>diag</TYPE>
     <START>$start</START>
     <END>$end</END>
     <STATUS>$status</STATUS>
   </PROCESS>
EOF

     }
  }
  require Process;
  my $L2 = Process->list();
  foreach my $p (@$L2) {
     print <<EOF;
  <PROCESS>
    <ID>$p->{pid}</ID>
    <TYPE>process.$p->{id}</TYPE>
    <START>$p->{start}</START>
    <END>$p->{end}</END>
    <STATUS>$p->{status}</STATUS>
  </PROCESS>
EOF
  }
  print "</PROCESSES>\n";

}

sub _status {
  my($p) = @_;

  if ($p->{status} eq "O") {
    return "Running";
  } elsif ($p->{status} eq "OQ")  {
    return "Waiting..";

  } elsif ($p->{rc} =~ /143/)  {
    return "Done:ABORTED";

  } elsif ( ( $p->{rc} >> 8 ) =~ /143/)  {
    return "Done:ABORTED";
  } elsif ($p->{rc} =~ /140/)  {
    return "Done:ISOLATED";

  } elsif ( ( $p->{rc} >> 8 ) =~ /140/)  {
    return "Done:ISOLATED";


  } elsif ($p->{rc} =~ /35072/)  {
    return "Done:ABORTED";

  }elsif ($p->{rc} =~ /999/)  {
    return "Done:SYNC";

  }
  elsif ($p->{rc} !~ /^[0\-,]+$/ ) {
    return "Done:ERROR";
  } else {
    return "Done:OK";
  }
}

#
#  Client::ProcMgr::runAgent&force=1&audit=1&nomax=1
#
sub runAgent {
  my($q) = @_;
  my $ID = "rasagent";
  my $process = Util->findProcessByName("/rasagent");
  if ($process) {
     print Client->error("xml", 402, "Process rasagent already running!");
     return;
  }

  print Client->http_OK();
  Process->start($ID);

  my $trace = "/opt/SUNWstade/DATA/tmp/$ID"  . "_trace";

  my $force = "-f" if ($q->{force});
  my $audit = "-A" if ($q->{audit});
  my $nomax = "-M" if ($q->{nomax});

  system("/opt/SUNWstade/bin/rasagent -d2 -r -a $force $audit $nomax -P > $trace 2>&1&");
  my $date = Util->get_today();
  print "<RUNAGENT>$date</RUNAGENT>\n";

}


1;
